'use strict';

var expand = function(name, source, target, mapping) {
  //TODO: pull existing items from source

  source.on('add', function(sourceKey) {
    var cause = name + '_' + sourceKey;

    if (mapping === undefined) {
      return target.add(sourceKey, cause);
    } 

    var targetKeys = mapping.values[sourceKey];
    if (targetKeys === undefined) { return; }

    for(var targetKey in targetKeys) {
      if (Object.prototype.hasOwnProperty.call(targetKeys, targetKey)) {
        target.add(targetKey, cause);
      }
    }
  });

  source.on('remove', function(sourceKey) {
    var cause = name + '_' + sourceKey;

    if (mapping === undefined) {
      return target.remove(sourceKey, cause);
    } 

    var targetKeys = mapping.values[sourceKey];
    if (targetKeys === undefined) { return; }

    for(var targetKey in targetKeys) {
      if (Object.prototype.hasOwnProperty.call(targetKeys, targetKey)) {
        target.remove(targetKey, cause);
      }
    }
  });
};

var exclude = function(name, source, target, mapping) {
  //TODO: pull existing items from source

  source.on('add', function(sourceKey) {
    var cause = name + "_" + sourceKey;

    if (mapping === undefined) {
      return target.supress(sourceKey, cause);
    }

    var targetKeys = mapping.values[sourceKey];
    if (targetKeys === undefined) { return; }

    for(var targetKey in targetKeys) {
      if (Object.prototype.hasOwnProperty.call(targetKeys, targetKey)) {
        target.supress(targetKey, cause);
      }
    }
  });

  source.on('remove', function(sourceKey) {
    var cause = name + "_" + sourceKey;

    if (mapping === undefined) {
      return target.unsupress(sourceKey, cause);
    }

    var targetKeys = mapping.values[sourceKey];
    if (targetKeys === undefined) { return; }

    for(var targetKey in targetKeys) {
      if (Object.prototype.hasOwnProperty.call(targetKeys, targetKey)) {
        target.unsupress(targetKey, cause);
      }
    }
  });
};

exports.expand = expand;
exports.exclude = exclude;
