'use strict';

var isArray = Array.isArray || function(obj) {
  return Object.prototype.toString.call(obj) === '[object Array]';
};

var has = function(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key);
};

var isEmpty = function(obj) {
  for(var key in obj) {
    if (has(obj, key)) { return false; }
  }
  return true;
};

exports.isArray = isArray;
exports.has = has;
exports.isEmpty = isEmpty;

